{Cannabola plot program written in Sub-Pascal language}

uses crt, graph;

const
  dt = 0.01;
  scale = 32.0;


var
  r, t, x, y: Real;

  gd, gm: integer;

begin

 gd := D8bit;
 gm := m640x480;

 InitGraph(gd,gm,'');
 
t := 0.0;

while t <= 2.0 * pi do
  begin
  r := (1.0 + sin(t)) * (1.0 + 0.9 * cos(8.0 * t)) * (1.0 + 0.2 * cos(24.0 * t)) * (0.5 + 0.05 * cos(200.0 * t));

  x := r * cos(t);
  y := r * sin(t);

  PutPixel(160 + round(scale * x), 100 - round(scale * y), 15);
  
  t := t + dt;
  end;

  repeat until keypressed;

end.



