
procedure Circle(x0,y0,radius: word);
//----------------------------------------------------------------------------------------------
// Bresenham Circle
//----------------------------------------------------------------------------------------------
var	x,y, txp, typ, txm, tym: word;
	d: smallint;

	procedure DrawCircle;
	begin
		PutPixel( txp, typ);
		PutPixel( txp, tym);
		PutPixel( txm, typ);
		PutPixel( txm, tym);
	end;

begin

	x := 0;
	y := radius;
	d := 3 - (radius shl 1);			// Decision criterion

	while (x <= y) do begin

		if d < 0 then				// d<0

			d := d + x shl 2 + 6		// Change in decision criterion for y -> y+1

		else begin

			d := d + (x - y) shl 2 + 10;	// Change for y -> y+1, x -> x-1
			dec(y);

		end;

	txp := x0+x;  typ := y0+y;
	txm := x0-x;  tym := y0-y;

	DrawCircle;

	txp := x0+y;  typ := y0+x;
	txm := x0-y;  tym := y0-x;

	DrawCircle;

	inc(x);

	end;

end;

