
procedure Ellipse(x0, y0, a, b: word);
//----------------------------------------------------------------------------------------------
// Ellipse
//----------------------------------------------------------------------------------------------
var	a2, b2, error, stopx, stopy: integer;
	x, y: word;

	procedure DrawEllipse;
	begin
		PutPixel(x0 + x, y0 + y);
		PutPixel(x0 - x, y0 + y);
		PutPixel(x0 - x, y0 - y);
		PutPixel(x0 + x, y0 - y);
	end;

begin
			if (a = 0) or (b = 0) then exit;

			a := abs(a);
			b := abs(b);
			a2 := (a * a) shl 1;
			b2 := (b * b) shl 1;
			error := a*a*b;
			x := 0;
			y := b;
			stopy := 0;
			stopx := a2 * b ;

			while (stopy <= stopx) do begin

				DrawEllipse;

				inc(x);
				error := error - b2 * (x - 1);
				stopy := stopy + b2;
				if (error <= 0) then begin
					error := error + a2 * (y - 1);
					dec(y);
					stopx := stopx - a2;
				end;
			end;
			
			error := b*b*a;
			x := a;
			y := 0;
			stopy := b2*a;
			stopx := 0;
			while (stopy >= stopx) do begin

				DrawEllipse;

				inc(y);
				error := error - a2 * (y - 1);
				stopx := stopx + a2;
				if (error < 0) then begin
					error := error + b2 * (x - 1);
					dec(x);
					stopy := stopy - b2;
				end;
			end;
end;
